"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _config = require("../../config");

var _jsxRuntime = require("react/jsx-runtime");

const getVerticalLineXY = data => {
  const {
    columnWidth,
    nodes,
    grid_height
  } = data;
  const topNodes = [];
  const bottomNodes = [];

  for (let i = 0; i < _config.GRID_COLUMN_NUM + 1; i++) {
    let x = _config.MARGIN_LEFT + i * columnWidth;
    topNodes.push([x, 0]);
    bottomNodes.push([x, grid_height]);
  }

  const res = [];

  for (let i = 0; i < _config.GRID_COLUMN_NUM + 1; i++) {
    res.push([topNodes[i], bottomNodes[i]]);
  }

  return res;
};

const getHorizontalLineXY = data => {
  const {
    columnWidth,
    nodes
  } = data;
  const leftNodes = [];
  const rightNodes = [];
  let temp_y = 0;
  leftNodes.push([_config.MARGIN_LEFT, temp_y]);
  rightNodes.push([_config.GRID_COLUMN_NUM * columnWidth + _config.MARGIN_LEFT, temp_y]);

  for (let i = 0; i < nodes.length; i++) {
    temp_y += nodes[i].row_height;
    leftNodes.push([_config.MARGIN_LEFT, temp_y]);
    rightNodes.push([_config.GRID_COLUMN_NUM * columnWidth + _config.MARGIN_LEFT, temp_y]);
  }

  const res = [];

  for (let i = 0; i < nodes.length + 1; i++) {
    res.push([leftNodes[i], rightNodes[i]]);
  }

  return res;
};

const GridBG = _ref => {
  let {
    nodes,
    columnWidth,
    showStartPercent,
    showPercent,
    grid_height
  } = _ref;
  const showIndex = showStartPercent * _config.GRID_COLUMN_NUM;
  const verticalLineXY = getVerticalLineXY({
    columnWidth,
    nodes,
    showStartPercent,
    showPercent,
    grid_height
  });
  const horizontalLineXY = getHorizontalLineXY({
    columnWidth,
    nodes,
    showStartPercent,
    showPercent
  });
  return (0, _jsxRuntime.jsxs)("g", {
    "data-com": "grid-lines",
    children: [verticalLineXY.map((line, i) => {
      if (i < showIndex) return null;
      return (0, _jsxRuntime.jsx)("line", {
        x1: line[0][0],
        y1: line[0][1],
        x2: line[1][0],
        y2: line[1][1],
        strokeDasharray: "5, 2",
        strokeWidth: "1",
        strokeOpacity: "0.09",
        stroke: "black"
      }, i);
    }), horizontalLineXY.map((line, i) => {
      return (0, _jsxRuntime.jsx)("line", {
        x1: line[0][0],
        y1: line[0][1],
        x2: line[1][0],
        y2: line[1][1],
        strokeDasharray: "5, 2",
        strokeWidth: "1",
        strokeOpacity: "0.09",
        stroke: "black"
      }, i);
    })]
  });
};

var _default = GridBG;
exports.default = _default;