"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _dayjs = _interopRequireDefault(require("dayjs"));

var _Tooltip = _interopRequireDefault(require("../../../Tooltip"));

var _config = require("../../../../config");

var _constant = require("../../util/constant");

var _bind = _interopRequireDefault(require("classnames/bind"));

var _css = _interopRequireDefault(require("./css"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let _s = _bind.default.bind(_css.default);

const TotalTime = _ref => {
  let {
    startX,
    startY,
    node,
    NODE_VALUE_END_X,
    NODE_END_DATE,
    startDate,
    data,
    msWidth
  } = _ref;
  let nodeStartTime = (0, _dayjs.default)(node.value.startTime).valueOf(),
      nodeEndTime = (0, _dayjs.default)(node.value.endTime).valueOf();

  const calcRectWidth = node => {
    const costTime = nodeEndTime - nodeStartTime;
    return costTime * msWidth;
  };

  const renderToolTip = node => {
    return (0, _jsxRuntime.jsxs)("div", {
      className: _s('g-tooltip'),
      children: [(0, _jsxRuntime.jsx)("div", {
        className: _s('status'),
        style: {
          background: true ? "#52C41A" : "#FA8C16"
        }
      }), (0, _jsxRuntime.jsx)("div", {
        className: _s('name'),
        children: node.name
      })]
    });
  };

  const rectWidth = calcRectWidth(node);
  const {
    showStartPercent,
    showPercent
  } = data;
  NODE_VALUE_END_X.push(startX * 1 + rectWidth * 1);
  NODE_END_DATE.push(nodeEndTime);
  const rect_y = node.averageTime ? startY * 1 + _constant.NODE_ATTRIBUTE.value.y : startY * 1 + _constant.NODE_ATTRIBUTE.value.y - _config.AVERAGE_TIME_RECT_HEIGHT;
  return (0, _jsxRuntime.jsx)("g", {
    "data-com": "Value",
    children: (0, _jsxRuntime.jsx)(_Tooltip.default, {
      content: renderToolTip(node),
      children: (0, _jsxRuntime.jsx)("rect", {
        x: startX * 1,
        y: rect_y,
        width: rectWidth,
        height: _constant.NODE_ATTRIBUTE.value.height,
        fill: "#52C41A"
      })
    })
  });
};

var _default = TotalTime;
exports.default = _default;