"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _dayjs = _interopRequireDefault(require("dayjs"));

var _Tooltip = _interopRequireDefault(require("../../../Tooltip"));

var _constant = require("../../util/constant");

var _config = require("../../../../config");

var _bind = _interopRequireDefault(require("classnames/bind"));

var _css = _interopRequireDefault(require("./css"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let _s = _bind.default.bind(_css.default);

const getTime = t => {
  const runTime = t / 1000;
  const seconds = runTime % 60;
  const minutes = (runTime - runTime % 60) / 60;
  const hours = (minutes - minutes % 60) / 60;
  if (hours) return "".concat(hours, " \u65F6 ").concat(minutes % 60, " \u5206 ").concat(seconds, " \u79D2");
  if (minutes) return "".concat(minutes, " \u5206 ").concat(seconds, " \u79D2");
  return "".concat(seconds, "s");
};

const WaitTime = _ref => {
  let {
    startX,
    startY,
    NODE_VALUE_END_X,
    NODE_END_DATE,
    node,
    data
  } = _ref;
  const lastNodeEndX = NODE_VALUE_END_X[NODE_VALUE_END_X.length - 1];
  const lastNodeEndDate = NODE_END_DATE[NODE_END_DATE.length - 1];
  const newNodeStartX = startX * 1;
  const {
    showPercent,
    showStartPercent
  } = data;
  const drawStartY = node.averageTime ? startY * 1 + _constant.NODE_ATTRIBUTE.value.y : startY * 1 + _constant.NODE_ATTRIBUTE.value.y - _config.AVERAGE_TIME_RECT_HEIGHT;
  if (lastNodeEndX >= newNodeStartX || !lastNodeEndX) return null;

  const renderWaitingText = data => {
    const {
      lastNodeEndX,
      newNodeStartX,
      startY
    } = data;
    if (newNodeStartX - lastNodeEndX <= 55) return null;
    const textX = (newNodeStartX - lastNodeEndX) / 2 + lastNodeEndX - 18;
    return (0, _jsxRuntime.jsxs)("g", {
      children: [(0, _jsxRuntime.jsx)("rect", {
        x: textX - 4,
        y: drawStartY - 3,
        width: "45",
        height: "17",
        fill: "#fff"
      }), (0, _jsxRuntime.jsx)("text", {
        x: textX,
        y: drawStartY + 10,
        fontSize: "12",
        fill: "#FFA940",
        children: "\u7B49\u5F85\u4E2D"
      })]
    });
  };

  const renderToolTip = node => {
    return (0, _jsxRuntime.jsxs)("div", {
      className: _s('g-tooltip'),
      children: [(0, _jsxRuntime.jsx)("div", {
        className: _s('status'),
        style: {
          background: true ? "#52C41A" : "#FA8C16"
        }
      }), (0, _jsxRuntime.jsx)("div", {
        className: _s('name'),
        children: node.name
      }), (0, _jsxRuntime.jsxs)("div", {
        className: _s('item'),
        children: [(0, _jsxRuntime.jsx)("div", {
          className: _s('key'),
          children: "\u7B49\u5F85\u65F6\u95F4"
        }), (0, _jsxRuntime.jsx)("div", {
          className: _s('value'),
          children: getTime((0, _dayjs.default)(node.value.startTime).valueOf() - lastNodeEndDate)
        })]
      })]
    });
  };

  return (0, _jsxRuntime.jsx)("g", {
    "data-com": "WaitTime",
    children: (0, _jsxRuntime.jsx)(_Tooltip.default, {
      content: renderToolTip(node),
      children: (0, _jsxRuntime.jsxs)("g", {
        children: [(0, _jsxRuntime.jsx)("line", {
          x1: lastNodeEndX + 1,
          y1: drawStartY + 6,
          x2: newNodeStartX - 1,
          y2: drawStartY + 6,
          strokeDasharray: "3, 3",
          strokeWidth: "1",
          stroke: "#FFA940"
        }), (0, _jsxRuntime.jsx)("line", {
          x1: lastNodeEndX + 1,
          y1: drawStartY,
          x2: lastNodeEndX + 1,
          y2: drawStartY + 12,
          strokeWidth: "1",
          stroke: "#FFA940"
        }), (0, _jsxRuntime.jsx)("line", {
          x1: newNodeStartX - 1,
          y1: drawStartY,
          x2: newNodeStartX - 1,
          y2: drawStartY + 12,
          strokeWidth: "1",
          stroke: "#FFA940"
        }), renderWaitingText({
          lastNodeEndX,
          newNodeStartX,
          startY
        })]
      })
    })
  });
};

var _default = WaitTime;
exports.default = _default;