"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _config = require("../../config");

var _YAxis = _interopRequireDefault(require("./YAxis"));

var _GridBG = _interopRequireDefault(require("./GridBG"));

var _Nodes = _interopRequireDefault(require("./Nodes"));

var _Blocking = _interopRequireDefault(require("./Blocking"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _css = _interopRequireDefault(require("./css"));

var _jsxRuntime = require("react/jsx-runtime");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let _s = _bind.default.bind(_css.default);

const ChartSvg = _ref => {
  let {
    data,
    svgWith,
    columnWidth,
    showPercent,
    showStartPercent,
    msWidth,
    startDate,
    endDate
  } = _ref;
  const {
    nodes,
    grid_height
  } = data;
  const svg_h = grid_height + _config.MARGIN_TOP;
  const offset = columnWidth * _config.GRID_COLUMN_NUM * showStartPercent;
  return (0, _jsxRuntime.jsx)("div", {
    className: _s('g-chart-container'),
    children: (0, _jsxRuntime.jsxs)("svg", {
      width: svgWith,
      height: svg_h,
      children: [(0, _jsxRuntime.jsxs)("g", {
        transform: "translate(".concat(-offset, ", ").concat(_config.MARGIN_TOP, ")"),
        children: [(0, _jsxRuntime.jsx)(_GridBG.default, {
          nodes,
          showPercent,
          showStartPercent,
          columnWidth,
          grid_height
        }), (0, _jsxRuntime.jsx)(_Nodes.default, {
          nodes,
          showPercent,
          showStartPercent,
          startDate,
          endDate,
          msWidth
        })]
      }), (0, _jsxRuntime.jsx)(_Blocking.default, {
        nodes,
        grid_height
      }), (0, _jsxRuntime.jsx)(_YAxis.default, {
        nodes: nodes
      })]
    })
  });
};

var _default = ChartSvg;
exports.default = _default;