"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = require("react");

var _reactDom = _interopRequireDefault(require("react-dom"));

var _bind = _interopRequireDefault(require("classnames/bind"));

var _css = _interopRequireDefault(require("./css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let _s = _bind.default.bind(_css.default);

function pointer(e, dom) {
  if (dom.getBoundingClientRect) {
    var rect = dom.getBoundingClientRect();
    return [e.clientX - rect.left - dom.clientLeft, e.clientY - rect.top - dom.clientTop];
  }
}

const Tooltip = _ref => {
  let {
    children,
    content
  } = _ref;
  const ref = (0, _react.useRef)({
    dom: null,
    renderify: false
  });
  (0, _react.useEffect)(() => {
    if (!ref.current.dom) {
      ref.current.dom = document.createElement('div');
      ref.current.dom.setAttribute('class', _s('box'));
    }

    return () => {
      ref.current.dom.remove();
    };
  }, []);

  const onMouseEnter = e => {
    if (!ref.current.renderify) {
      ref.current.renderify = true;
      document.querySelector('body').append(ref.current.dom);

      _reactDom.default.render(content, ref.current.dom);
    }

    ref.current.dom.style.opacity = 1;
    document.body.style.cursor = 'crosshair';
  };

  const onMouseMove = e => {
    let [x, y] = pointer(e, document.querySelector('body'));
    ref.current.dom.style.left = "".concat(x, "px");
    ref.current.dom.style.top = "".concat(y, "px");
  };

  const onMouseLeave = e => {
    ref.current.dom.style.opacity = 0;
    document.body.style.cursor = 'auto';
  };

  return (0, _react.cloneElement)(children, {
    onMouseEnter,
    onMouseMove,
    onMouseLeave
  });
};

var _default = Tooltip;
exports.default = _default;